#ifndef AOCPP_STARTUP_HPP_
#define AOCPP_STARTUP_HPP_

#include <fstream>
#include <iostream>
#include <memory>
#include <optional>

namespace aocpp {

class ConditionalDeleter {
  bool should_delete_;

public:
  ConditionalDeleter(bool should_delete) : should_delete_ {should_delete} {}
  
  template <typename T>
  auto operator()(T * pointer) -> void { if (should_delete_) { delete pointer; }}
};

auto Startup(int argc, char ** argv) -> std::unique_ptr<std::istream, ConditionalDeleter>;

}

#endif
